
Spielfeld = require"spielfeld"

local BallsTurn = Game:addState("BallsTurn")

function BallsTurn:enteredState()
	
	local toGrow = { }
	for i, v in ipairs(self.ui.map.mapByContent[1]) do
		table.insert(toGrow, {v, self.ui.map.map[v].col})
	end
	for i, v in ipairs(toGrow) do
		local special
		if love.math.random(10) == 1 then special = Spielfeld.static.specials[love.math.random(#Spielfeld.static.specials)] end
		self.ui.map:setPos{coordStr = v[1], size = 2, col = v[2], special = special}
	end
	for i, v in ipairs(toGrow) do
		self:checkForFive(v[1])
	end
	
	local growAmount = math.min(4, #self.ui.map.mapByContent[0])
	for i = 1, growAmount do
		local newSmall = self.ui.map.mapByContent[0][love.math.random(#self.ui.map.mapByContent[0])] -- get random empty field
		self.ui.map:setPos{coordStr = newSmall, size = 1, col = love.math.random(Spielfeld.static.maxColors)}
	end
	
	if #self.ui.map.mapByContent[0] < 2 then
		self:gotoState("Gameover")
	else
		self:gotoState("Player_Wait1st")
	end
	
end


function BallsTurn:draw()
	
	self.ui.map:draw(self.ui.mapX_Offs, self.ui.mapY_Offs)
	self.ui:draw(self.displayStats)
	
end



function BallsTurn:keypressed(key)
	
	if key == "escape" then self:gotoState("Menu")
	elseif key == "tab" then self:toggleFullscreen()
	end
	
end


function BallsTurn:mousemoved(x, y)
	
	local _, _, coordStr = self.ui:getClickedField(x, y)
	if coordStr then self.ui:displayFieldDebugInfo(coordStr, x, y) else self.ui.debugInfo = "" end
	
end




