
local Stack = require"stack"
local Spielfeld = require"spielfeld"

local Player_Wait2nd = Game:addState("Player_Wait2nd")



function Player_Wait2nd:enteredState()
	
	local stack = Stack()
	stack:push(self.playermove_start)
	
	self.ui.map:setPos{coordStr = self.playermove_start, size = 0, col = self.ui.map.floodfillColorindex, special = self.ui.map.map[self.playermove_start].special}
	
	local currStr, currX, currY
	while not stack:isEmpty() do
		
		currStr = stack:pop()
		currX, currY = Spielfeld.static.splitCoordString(currStr)
		
		if self.ui.map.map[currStr].ffcol == 0 then
			local currSize, currCol = self.ui.map.map[currStr].size, self.ui.map.map[currStr].col
			self.ui.map:setPos{x = currX, y = currY, size = currSize, col = currCol, ffcol = self.ui.map.floodfillColorindex, special = self.ui.map.map[self.playermove_start].special}
			stack:push(Spielfeld.static.getCoordString(currX + 1, currY))
			stack:push(Spielfeld.static.getCoordString(currX - 1, currY))
			stack:push(Spielfeld.static.getCoordString(currX, currY + 1))
			stack:push(Spielfeld.static.getCoordString(currX, currY - 1))
		end
		
	end
	self.ui.map:setPos{coordStr = self.playermove_start, size = 2, col = self.ui.map.floodfillColorindex, highl = true, special = self.ui.map.map[self.playermove_start].special}
	
end



function Player_Wait2nd:draw()
	
	self.ui.map:draw(self.ui.mapX_Offs, self.ui.mapY_Offs)
	self.ui:draw(self.displayStats)
	
end



function Player_Wait2nd:keypressed(key)
	
	if key == "escape" then self:gotoState("Menu")
	elseif key == "tab" then self:toggleFullscreen()
	end
	
end



function Player_Wait2nd:mousemoved(x, y)
	
	local _, _, coordStr = self.ui:getClickedField(x, y)
	if coordStr then self.ui:displayFieldDebugInfo(coordStr, x, y) else self.ui.debugInfo = "" end
	
end



function Player_Wait2nd:mousepressed(x, y, button)
	
	local _, _, coordStr = self.ui:getClickedField(x, y)
	if coordStr then
		local size, color, ffcol = self.ui.map.map[coordStr].size, self.ui.map.map[coordStr].col, self.ui.map.map[coordStr].ffcol
		local startPos = self.playermove_start
		local startPosSize, startPosColor, startPosSpecial = self.ui.map.map[startPos].size, self.ui.map.map[startPos].col, self.ui.map.map[startPos].special
		
		if size <= 1 and ffcol == startPosColor then
			
			self.ui.map:setPos{coordStr = startPos, size = 0, col = startPosColor, special = "none"}
			self.ui.map:setPos{coordStr = coordStr, size = startPosSize, col = startPosColor, special = startPosSpecial}
			self:undo1stClick()
			self:checkForFive(coordStr)
			self.displayStats.turns = self.displayStats.turns + 1
			
			if #self.ui.map.mapByContent[0] < 2 then
				--self:gotoState("Gameover")
			else
				self:gotoState("BallsTurn")
			end
			
		else
			self:undo1stClick()
			self:gotoState("Player_Wait1st")
		end
		
	end
	
end





